from graphene_django import DjangoObjectType

from aleksis.core.schema.base import (
    BaseBatchCreateMutation,
    BaseBatchDeleteMutation,
    BaseBatchPatchMutation,
    PermissionsTypeMixin,
)

from ..models import EventAdditionalField


class EventAdditionalFieldType(PermissionsTypeMixin, DjangoObjectType):
    class Meta:
        model = EventAdditionalField


class EventAdditionalFieldBatchCreateMutation(BaseBatchCreateMutation):
    class Meta:
        model = EventAdditionalField
        permissions = ("paweljong.create_event_additional_field_rule",)
        only_fields = (
            "title",
            "field_type",
            "required",
            "help_text",
        )


class EventAdditionalFieldBatchDeleteMutation(BaseBatchDeleteMutation):
    class Meta:
        model = EventAdditionalField
        permissions = ("paweljong.delete_event_additional_field_rule",)


class EventAdditionalFieldBatchPatchMutation(BaseBatchPatchMutation):
    class Meta:
        model = EventAdditionalField
        permissions = ("paweljong.edit_event_additional_field_rule",)
        only_fields = (
            "id",
            "title",
            "field_type",
            "required",
            "help_text",
        )
